VERSION 5.00
Begin VB.Form FMain 
   Caption         =   "ASCII Base 85 Class - Test Applicaton"
   ClientHeight    =   4440
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6165
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4440
   ScaleWidth      =   6165
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDisplay 
      Appearance      =   0  'Flat
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4395
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "FMain.frx":0000
      Top             =   0
      Width           =   6135
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSeparator 
         Caption         =   "-"
         Index           =   0
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditEncode 
         Caption         =   "ASCII Base 85 Encode"
         Shortcut        =   ^E
      End
      Begin VB.Menu mnuFileDecode 
         Caption         =   "ASCII Base 85 Decode"
         Shortcut        =   ^D
      End
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Variable to hold status of text
Private bolTextDirty As Boolean

' Variable to hold the instance of the ASCII Base 85 class
Private objBase85 As clsASCIIBase85

Private Sub Form_Load()
    ' Create an instance of the class
    Set objBase85 = New clsASCIIBase85
    txtDisplay.Text = "Why not encode this text many times over," & vbCrLf & "then decode until you get the origional text." & vbCrLf & "Anything come to mind?"
End Sub

Private Sub Form_Resize()
    ' Resize the text box in the form so long as the application is not minimized.
    If Me.WindowState <> vbMinimized Then
        txtDisplay.Height = Me.ScaleHeight
        txtDisplay.Width = Me.ScaleWidth
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Cleanup
    Set objBase85 = Nothing
End Sub

Private Sub mnuEditEncode_Click()
    Dim aTempEncode() As Byte
    
    aTempEncode = StringToArray(txtDisplay.Text)
    txtDisplay.Text = objBase85.Encode(aTempEncode)
End Sub

Private Sub mnuFileDecode_Click()
    Dim aTempDecode() As Byte
    
    aTempDecode = objBase85.Decode(txtDisplay.Text)
    txtDisplay.Text = ArrayToString(aTempDecode)
End Sub

Private Sub mnuFileExit_Click()
    ' Call the form Unload method
    Unload Me
End Sub

Private Sub mnuFileNew_Click()
    ' Has the text been modified?
    If bolTextDirty Then
        ' Prompt to save
        If MsgBox("The text has been modified.  Are you sure?", vbYesNo, App.Title) = vbYes Then
            ' Empty the text box
            txtDisplay.Text = vbNullString
        End If
    End If
End Sub

Private Sub mnuFileOpen_Click()
    ' Has the current text been modified?
    If bolTextDirty Then
        ' Prompt to save code here
    End If
    
    ' Open the file code here
    
    bolTextDirty = False
End Sub

Private Sub mnuFileSave_Click()
    ' Save the file code here
    
    bolTextDirty = False
End Sub

Private Sub txtDisplay_Change()
    ' Text is dirty, set the marker.
    bolTextDirty = True
    txtDisplay.ToolTipText = "Length of text = " & Len(txtDisplay.Text)
End Sub

' ------------------------
' Support Routines
' ------------------------

' Class methods require byte arrays, it might be more than text
' that is being encoded.  Perhaps other data formats... JPEG etc.
Private Function StringToArray(ByVal strIn As String) As Byte()
    Dim x As Long
    Dim nNewBuffer() As Byte
    
    ReDim nNewBuffer(Len(strIn) - 1)
    
    For x = 0 To Len(strIn) - 1
        nNewBuffer(x) = Asc(Mid$(strIn, x + 1, 1))
    Next x
    
    StringToArray = nNewBuffer
End Function

Private Function ArrayToString(ByRef bArrayIn() As Byte) As String
    Dim x As Long
    Dim strTemp As String
    
    For x = 0 To UBound(bArrayIn)
        strTemp = strTemp & Chr$(bArrayIn(x))
    Next x
    
    ArrayToString = strTemp
End Function
